<!DOCTYPE html>
<html lang="en" style="height: 100%">

<head>
  <meta charset="utf-8">
  <title>Oxfam - #OHLAVACHE</title>
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />
  <meta name="robots" content="noindex">
  <link rel="stylesheet" href="css/oxfam.css">
  <script src="js/tmpl.min.js"></script>
</head>

<body>
  <img src="/logos/OX_OFR_VL_blanc_RGB.png" alt="logo-oxfam" class="logo" />
  <div class="header">
    <h1 id="app-title">#OHLAVACHE</h1>
  </div>
  <div class="container">
    <!-- SCREEN 1 -->
    <div class='screen' id="screen-1"></div>
    <!-- SCREEN 2 -->
    <div class='screen' id="screen-2"></div>
    <!-- SCREEN 3 -->
    <div class='screen' id="screen-3"></div>
    <!-- SCREEN 4 -->
    <div class='screen' id="screen-4"></div>
    <!-- SCREEN 5 : error -->
    <div class='screen' id="screen-5"></div>
  </div>

  <!-- TEMPLATE SCREEN 1 -->
  <script type="text/x-tmpl" id="tmpl-screen-1" style="display: none;">
    <div class="stepper">
      <div class="step">
        <div class='step-number'>1</div>
        <div class="step-description">Calcule ton empreinte</div>
      </div>
      <div class="step">
        <div class="step-number">2</div>
        <div class="step-description">Compare-toi à un milliardaire</div>
      </div>
      <div class="step">
        <div class="step-number">3</div>
        <div class="step-description">Partage ton résultat</div>
      </div>
    </div>
    <div class="actions">
      <button class="btn" onclick="goToScreen2();">
        Commencer
      </button>
    </div>
  </script>

  <!-- TEMPLATE SCREEN 2 -->
  <script type="text/x-tmpl" id="tmpl-screen-2" style="display: none;">
    <div class='screen-wrapper'>
      <div class="current-step">
        <div class="step">
          <div class='step-number'>1</div>
          <div class="step-description">Calcule ton empreinte</div>
        </div>
      </div>
      <div class="user-inputs">
        <div class='input-wrapper'>
          <label for="savingsAmount">
            Quel est le montant de ton patrimoine ?
          </label>
          <div class="savings-wrapper">
            <input
              type="text"
              id="savingsAmount"
              placeholder="30 000"
              oninput="changeAmountHandler()"
            />
            <span class="addon">€</span>
          </div>
        </div>

        <div class='input-wrapper'>
          <label for="bank">
            Quel est le nom de ta banque ?
          </label>
          <select name="bank" id="bank" oninput="changeBanckHandler()">
            <option value="">Sélectionnez votre banque</option>
            {% for (var i=0; i<o.banks.length; i++) { %}
            <option value="{%=i%}">{%=o.banks[i][0]%}</option>
            {% } %}
          </select>
        </div>
      </div>
    </div>
    <div class="actions">
      <button
        class='btn'
        id='screen2-confirm'
        onclick="goToScreen3()"
      >SUIVANT</button>
    </div>

  </script>

  <!-- TEMPLATE SCREEN 3 -->
  <script type="text/x-tmpl" id="tmpl-screen-3" style="display: none;">
    <div class='screen-wrapper'>
      <div class="current-step">
        <div class="step">
          <div class="step-number">2</div>
          <div class="step-description">Compare-toi à un milliardaire</div>
        </div>
      </div>
      <div class="user-inputs">
        <div class='input-wrapper'>
          <label for="bank">
            A quel milliardaire veux-tu te comparer ?
          </label>
        </div>
        <div class="billionaire-wrapper">
          {% for (var i=0; i<o.billionaires.length; i++) { %}
            <button
              class="billionaire-button"
              id="billionaire-button-{%=i%}"
              onclick="onBillionaireClick(this, '{%=o.billionaires[i].name%}')"
            >
              <figure class="billionaire-figure">
                <img
                  class="billionaire-img"
                  id="billionaire-img-{%=i%}"
                  src="/images/OhLaVacheSmiley.png"
                  alt={%=o.billionaires[i].name%}
                  title={%=o.billionaires[i].name%}
                />
                <figcaption>{%=o.billionaires[i].name%}</figcaption>
              </figure>
            </button>
          {% } %}
        </div>
        <div class="input-wrapper">
          <label for="user-name">
            Renseigne ton prénom pour personnaliser ton visuel
          </label>
          <div class="user-name" id="user-name">
            <input
              type="text"
              id="name"
              placeholder="Prénom"
              oninput="changeNameHandler()"
            />
          </div>
        </div>
      </div>
    </div>

    <div class="actions">
      <button
        class="btn button-disabled"
        id="screen3-confirm"
        onclick="goToScreen4()"
        disabled
      >
        GÉNÈRE TON VISUEL
        <div class="loader" id="loader-generate-image"></div>
      </button>
    </div>
  </script>

  <!-- TEMPLATE SCREEN 4 -->
  <script type="text/x-tmpl" id="tmpl-screen-4" style="display: none;">
    <div class='screen-wrapper'>
      <div class="current-step">
        <div class="step">
          <div class="step-number">3</div>
          <div class="step-description">Partage ton résultat</div>
        </div>
      </div>
      <div class="input-wrapper">
        <div>
          <img
            src="{%=imageUrl%}"
            alt="image #OHLAVACHE"
            class="image-ohlavache"
          />
          <div class="actions">
            <button
              class="btn"
              id="screen4-share"
              onclick="onTweetButtonHandler('{%=selectedBillionaire.name%}')"
            >PARTAGER SUR TWITTER</button>
            <button
              class="btn"
              id="screen4-download"
              onclick="download('{%=imageUrl%}')"
            >TÉLÉCHARGER LE VISUEL</button>
          </div>
        </div>
      </div>
    </div>
  </script>

  <!-- TEMPLATE SCREEN 5 : error -->
  <script type="text/x-tmpl" id="tmpl-screen-5" style="display: none;">
    <div class="screen-wrapper">
      <div>
        <img
          class="error-image"
          src="/images/cow-white.png"
          alt="illustration erreur"
        />
      </div>
      <p class="error-message">Nous sommes désolés, une erreur est survenue, veuillez essayer ultérieurement !</p>
    </div>
    <div class="actions">
      <button class="btn" onclick="goToScreen1(5);">
        Recommencer
      </button>
    </div>
  </script>

  <script type="application/javascript">
    var BANKS = [
      ["Banque Populaire - Caisse d'Epargne", 379],
      ['BNP Paribas', 601],
      ['Crédit Agricole', 444],
      ['Crédit Mutuel', 379],
      ["La Banque Postale", 353],
      ['LCL', 444],
      ['CIC', 379],
      ['Société Générale', 652],
    ]
    var BILLIONAIRES = [
      { name: 'Bernard', cowDungImpact: "241 465M" },
      { name: 'Vincent', cowDungImpact: "508 464M" },
      { name: 'Xavier', cowDungImpact: "33 860M" },
    ]
    var COW_DUNG_CONVERTER = 1 / 9.5

    var userAmount = null
    var selectedBillionaire = null
    var name = ''
    var bankName = ''
    var savingsAmount = 0 // in €
    var co2Impact = 0 // in 0.01.tonnes
    var co2ImpactShow = 0
    var cowDungImpact = null
    var cowDungImpactShow = null
    var multiplier = null

    var imageUrl = 'images/result.png'

    var bankCoeff = null
    var numbers = "0123456789".split('')

    var errorMessage

    function addSpaces(numberStr) {
      if (numberStr.length <= 3) {
        return numberStr
      }
      if (numberStr.length > 3) {
        return addSpaces(numberStr.substr(0, numberStr.length - 3)) + ' ' + numberStr.substr(numberStr.length - 3)
      }
    }

    function roundImpact(value) {
      if (value == null) {
        return
      }
      if (value > 10) {
        return Math.round(value)
      }
      if (value > 1) {
        return value.toFixed(1)
      }
      if (value > 0.1) {
        return value.toFixed(2)
      }
      if (value > 0.01) {
        return value.toFixed(3)
      }
      if (value > 0.001) {
        return value.toFixed(4)
      }
      if (value > 0.0001) {
        return value.toFixed(5)
      }
      return value.toPrecision(2)
    }

    function computeValues() {
      if (userAmount && bankCoeff) {
        co2Impact = userAmount / 1e6 * bankCoeff
        cowDungImpact = co2Impact * COW_DUNG_CONVERTER
      } else {
        co2Impact = null
        cowDungImpact = null
      }
      co2ImpactShow = roundImpact(co2Impact) + "M"
      cowDungImpactShow = roundImpact(cowDungImpact) + "M"

      var billionaireCowDown = parseInt(selectedBillionaire.cowDungImpact.split("M")[0].replace(/\s+/g, ""))
      multiplier = addSpaces(roundImpact(billionaireCowDown / cowDungImpact).toString())
    }

    function checkValuesScreen2AreValid() {
      var confirmBtn = document.getElementById('screen2-confirm')
      if (userAmount && bankCoeff) {
        confirmBtn.classList.remove('button-disabled')
        confirmBtn.disabled = false
      } else {
        confirmBtn.classList.add('button-disabled')
        confirmBtn.disabled = true
      }
    }

    function checkValuesScreen3AreValid() {
      var confirmBtn = document.getElementById('screen3-confirm')
      if (userAmount && bankCoeff && name && selectedBillionaire) {
        confirmBtn.classList.remove('button-disabled')
        confirmBtn.disabled = false
      } else {
        confirmBtn.classList.add('button-disabled')
        confirmBtn.disabled = true
      }
    }

    function changeAmountHandler() {
      var amount = document.getElementById('savingsAmount').value
      // only keep numbers
      amount = amount.split('').filter(function (letter) { return numbers.indexOf(letter) != -1 }).join('')

      userAmount = parseInt(amount)
      // add spaces
      amount = addSpaces(amount)
      document.getElementById('savingsAmount').value = amount
      checkValuesScreen2AreValid()
    }

    function changeBanckHandler() {
      var bankId = parseInt(document.getElementById('bank').value || -1)
      if (bankId == null || bankId === -1) {
        bankName = ''
        bankCoeff = null
      } else {
        var bank = BANKS[bankId]
        bankName = bank[0]
        bankCoeff = bank[1]
      }
      checkValuesScreen2AreValid()
    }

    function changeNameHandler() {
      name = document.getElementById('name').value
      checkValuesScreen3AreValid()
    }

    function onBillionaireClick(e, name) {
      var buttons = document.getElementsByClassName('billionaire-button')
      for (let i = 0; i < buttons.length; i++) {
        buttons[i].classList.remove('billionaire-button-selected')
      }

      var id = e.id
      elm = document.getElementById(id)
      elm.classList.add('billionaire-button-selected')

      selectedBillionaire = BILLIONAIRES.filter((x) => x.name === name)[0]
      checkValuesScreen3AreValid()
    }

    function onTweetButtonHandler(name) {
      var text = encodeURI("Je viens de comparer l’empreinte carbone de mon patrimoine financier à celle de " + name + ". J’ai calculé en Millions de bouses de vaches pour me faire une meilleure idée…")
      var hashtags = "OhLaVache"
      var url = "https://www.oxfamfrance.org/vaches-milliardaires-et-climat/"
      var link = "https://twitter.com/intent/tweet?text=" + text + "&hashtags=" + hashtags + "&url=" + url
      window.open(link, '_blank').focus()
    }


    function updateTemplate(screenId) {
      var data = {
        banks: BANKS,
        billionaires: BILLIONAIRES,
      }

      document.getElementById('screen-' + screenId).innerHTML = tmpl(
        'tmpl-screen-' + screenId, data
      )

      return true
    }

    // navigation
    function showElement(divId) {
      document.getElementById(divId).style.display = 'block'
    }
    function hideElement(divId) {
      document.getElementById(divId).style.display = 'none'
    }
    function screenOpacity(screenId, opacity) {
      document.getElementById('screen-' + screenId).style.opacity = opacity
    }
    function screenTransition(prevScreenId, nextScreenId) {
      screenOpacity(prevScreenId, 0)
      setTimeout(function () {
        hideElement('screen-' + prevScreenId)
        showElement('screen-' + nextScreenId)
        setTimeout(function () {
          screenOpacity(nextScreenId, 1)
        }, 200)
      }, 200)
    }
    function showScreen(screenId) {
      hideElement('screen-1')
      hideElement('screen-2')
      hideElement('screen-3')
      hideElement('screen-4')
      hideElement('screen-5')
      showElement('screen-' + screenId)
    }

    // user actions
    function goToScreen1(current) {
      updateTemplate(1)
      showScreen(1)
      screenTransition(current, 1)
    }

    function goToScreen2() {
      updateTemplate(2)
      showScreen(2)
      screenTransition(1, 2)
      checkValuesScreen2AreValid();;
    }

    function goToScreen3() {
      updateTemplate(3)
      screenTransition(2, 3)
      checkValuesScreen3AreValid()
    }

    // backend requests
    function sendNewEntry() {
      var xhr = new XMLHttpRequest()
      xhr.open("get", "/entry", true)
      xhr.send()
    }
    function getImage(updateTemplate, screenTransition, currentScreen) {
      var xhr = new XMLHttpRequest()
      var user = { name, cowDungImpact: cowDungImpactShow }

      xhr.open("POST", "https://d08vwgx631.execute-api.eu-west-3.amazonaws.com/default/oxfamMegaBousesImage", true)
      xhr.setRequestHeader('Content-Type', 'application/json;charset=UTF-8')
      document.getElementById('loader-generate-image').style.display = 'block'

      xhr.onreadystatechange = function () {
        if (this.readyState === XMLHttpRequest.DONE && this.status >= 200 && this.status < 400) {
          var data = JSON.parse(this.response)
          if (data.image_url) {
            imageUrl = data.image_url
            updateTemplate(currentScreen + 1)
            screenTransition(currentScreen, currentScreen + 1)
          }
        }
        if (this.status >= 400) {
          updateTemplate(5)
          screenTransition(currentScreen, 5)
        }
      }
      xhr.send(JSON.stringify({
        user,
        billionaire: selectedBillionaire,
        multiplier,
        result: selectedBillionaire.name + " pollue " + multiplier + " fois plus que moi !"
      }))
    }

    function goToScreen4() {
      computeValues()
      getImage(updateTemplate, screenTransition, 3)
      sendNewEntry()
    }

    function download(fileUrl) {
      window.open(fileUrl, '_blank').focus()

      // not working anymore with external url
      // var a = document.createElement("a");
      // a.href = fileUrl;
      // a.setAttribute("download", 'oxfam-ohlavache.png');
      // a.click();
    }

    // to test when cors opened
    // function download(url){
    //   var xhr = new XMLHttpRequest();
    //   xhr.open("GET", url, true);
    //   xhr.responseType = "blob";
    //   xhr.onload = function(){
    //       var urlCreator = window.URL || window.webkitURL;
    //       var imageUrl = urlCreator.createObjectURL(this.response);
    //       var tag = document.createElement('a');
    //       tag.href = imageUrl;
    //       tag.download = 'oxfam-ohlavache.png';
    //       document.body.appendChild(tag);
    //       tag.click();
    //       document.body.removeChild(tag);
    //   }
    //   xhr.send();
    // }

    // executes after html load
    (function () {
      updateTemplate(1)
      showScreen(1)
      screenTransition(1, 1)
    })();
  </script>
</body>

</html>